/* This file has been generated by the VFPG from tests/regression-tests/guided.xml */
/* Version v6.0_unstable-none--dirty */
/* Please DO NOT EDIT */

#ifndef FLIGHT_PLAN_H
#define FLIGHT_PLAN_H

#include "std.h"
#include "generated/modules.h"
#include "modules/core/abi.h"
#include "autopilot.h"


#define FLIGHT_PLAN_NAME "Small1"
#define NAV_DEFAULT_ALT 260 /* nominal altitude of the flight plan */
#define NAV_UTM_EAST0 360285
#define NAV_UTM_NORTH0 4813595
#define NAV_UTM_ZONE0 31
#define NAV_LAT0 434622300 /* 1e7deg */
#define NAV_LON0 12728900 /* 1e7deg */
#define NAV_ALT0 185000 /* mm above msl */
#define NAV_MSL0 51850 /* mm, EGM96 geoid-height (msl) over ellipsoid */
#define QFU 1.0
#define WP_dummy 0
#define WP_HOME 1
#define WP_P1 2
#define WP_P2 3
#define WP_P3 4
#define WP_P4 5
#define WP_P5 6
#define WP_P6 7
#define WAYPOINTS_UTM { \
 {0.0, 0.0, 260},\
 {0.0, 0.0, 260},\
 {0.0, 0.0, 260},\
 {100.0, 100.0, 260},\
 {100.0, 100.0, 260},\
 {100.0, 100.0, 260},\
 {100.0, 100.0, 260},\
 {100.0, 100.0, 260},\
};
#define WAYPOINTS_ENU { \
 {0.00, -0.00, 75.00}, /* ENU in meters  */ \
 {0.00, -0.00, 75.00}, /* ENU in meters  */ \
 {0.00, -0.00, 75.00}, /* ENU in meters  */ \
 {97.92, 102.07, 75.00}, /* ENU in meters  */ \
 {97.92, 102.07, 75.00}, /* ENU in meters  */ \
 {97.92, 102.07, 75.00}, /* ENU in meters  */ \
 {97.92, 102.07, 75.00}, /* ENU in meters  */ \
 {97.92, 102.07, 75.00}, /* ENU in meters  */ \
};
#define WAYPOINTS_LLA { \
 {.lat=434622299, .lon=12728900, .alt=260000}, /* 1e7deg, 1e7deg, mm (above NAV_MSL0, local msl=51.85m) */ \
 {.lat=434622299, .lon=12728900, .alt=260000}, /* 1e7deg, 1e7deg, mm (above NAV_MSL0, local msl=51.85m) */ \
 {.lat=434622299, .lon=12728900, .alt=260000}, /* 1e7deg, 1e7deg, mm (above NAV_MSL0, local msl=51.85m) */ \
 {.lat=434631486, .lon=12741000, .alt=260000}, /* 1e7deg, 1e7deg, mm (above NAV_MSL0, local msl=51.85m) */ \
 {.lat=434631486, .lon=12741000, .alt=260000}, /* 1e7deg, 1e7deg, mm (above NAV_MSL0, local msl=51.85m) */ \
 {.lat=434631486, .lon=12741000, .alt=260000}, /* 1e7deg, 1e7deg, mm (above NAV_MSL0, local msl=51.85m) */ \
 {.lat=434631486, .lon=12741000, .alt=260000}, /* 1e7deg, 1e7deg, mm (above NAV_MSL0, local msl=51.85m) */ \
 {.lat=434631486, .lon=12741000, .alt=260000}, /* 1e7deg, 1e7deg, mm (above NAV_MSL0, local msl=51.85m) */ \
};
#define WAYPOINTS_LLA_WGS84 { \
 {.lat=434622299, .lon=12728900, .alt=311850}, /* 1e7deg, 1e7deg, mm (above WGS84 ref ellipsoid) */ \
 {.lat=434622299, .lon=12728900, .alt=311850}, /* 1e7deg, 1e7deg, mm (above WGS84 ref ellipsoid) */ \
 {.lat=434622299, .lon=12728900, .alt=311850}, /* 1e7deg, 1e7deg, mm (above WGS84 ref ellipsoid) */ \
 {.lat=434631486, .lon=12741000, .alt=311850}, /* 1e7deg, 1e7deg, mm (above WGS84 ref ellipsoid) */ \
 {.lat=434631486, .lon=12741000, .alt=311850}, /* 1e7deg, 1e7deg, mm (above WGS84 ref ellipsoid) */ \
 {.lat=434631486, .lon=12741000, .alt=311850}, /* 1e7deg, 1e7deg, mm (above WGS84 ref ellipsoid) */ \
 {.lat=434631486, .lon=12741000, .alt=311850}, /* 1e7deg, 1e7deg, mm (above WGS84 ref ellipsoid) */ \
 {.lat=434631486, .lon=12741000, .alt=311850}, /* 1e7deg, 1e7deg, mm (above WGS84 ref ellipsoid) */ \
};
#define WAYPOINTS_GLOBAL { \
 FALSE, \
 FALSE, \
 FALSE, \
 FALSE, \
 FALSE, \
 FALSE, \
 FALSE, \
 FALSE, \
};
#define NB_WAYPOINT 8
#define FP_BLOCKS { \
 "INIT_BLOCK" , \
 "Test Nav" , \
 "HOME" , \
}
#define NB_BLOCKS 3
#define GROUND_ALT 185.
#define GROUND_ALT_CM 18500
#define SECURITY_HEIGHT 25.
#define SECURITY_ALT 210.
#define HOME_MODE_HEIGHT 25.
#define MAX_DIST_FROM_HOME 1500.


#ifndef FBW


#endif

#ifdef NAV_C


static inline void auto_nav_init(void) {
}

unsigned char const nb_blocks = 3;

void on_enter_block(unsigned char block)
{
  switch (block) {
    default:
      break;
    
  }
}

void on_exit_block(unsigned char block)
{
  switch (block) {
    default:
      break;
    
  }
}

_Bool forbidden_deroute(unsigned char from, unsigned char to)
{
  switch (from) {
    default:
      break;
    
  }
  return (_Bool) 0;
}

static inline void auto_nav(void)
{
  unsigned char tmp_nav_block;
  unsigned char tmp_nav_stage;
  _Bool tmp_cond;
  float tmp_RadOfDeg;
  float tmp_AltitudeMode;
  _Bool tmp_NavCond;
  tmp_nav_block = get_nav_block();
  switch (tmp_nav_block) {
    case 0:
      tmp_nav_stage = get_nav_stage();
      switch (tmp_nav_stage) {
        default:
          set_nav_stage(0);
          NextBlock();
          break;
        
      }
      break;
    case 1:
      tmp_nav_stage = get_nav_stage();
      switch (tmp_nav_stage) {
        case 0:
          set_nav_stage(0);
          NavGuided(0, test);
          break;
        case 1:
          set_nav_stage(1);
          NavGuided(test1, test);
          break;
        case 2:
          set_nav_stage(2);
          NavGuided(test1, test);
          if (test2()) {
            NextStage();
            break;
          }
          break;
        case 3:
          set_nav_stage(3);
          (pre);
          NavGuided(test1, test);
          if (test2()) {
            (post);
            NextStage();
            break;
          }
          (post);
          break;
        case 4:
          set_nav_stage(4);
          RotorGuided(test1, test);
          if (test2()) {
            NextStage();
            break;
          }
          break;
        case 5:
          set_nav_stage(5);
          RotorGuided(test1, test, 10);
          if (test2()) {
            NextStage();
            break;
          }
          break;
        case 6:
          set_nav_stage(6);
          NavGuided
            (GUIDED_FLAG_XY_OFFSET_Z_VEL,
             0.,0.,-climb_descent_vel,desired_heading);
          if ((GetPosHeight()>1.000000)) {
            NextStage();
            break;
          }
          break;
        case 7:
          set_nav_stage(7);
          NavGuided(0, 0.,0.,-nominal_alt,desired_heading);
          if (FALSE) {
            NextStage();
            break;
          }
          break;
        case 8:
          set_nav_stage(8);
          NavGuided(0, 2.,2.,-nominal_alt,desired_heading);
          if ((stage_time>5)) {
            NextStage();
            break;
          }
          break;
        case 9:
          set_nav_stage(9);
          NavGuided(0, -2.,2.,-nominal_alt,desired_heading);
          if ((stage_time>5)) {
            NextStage();
            break;
          }
          break;
        case 10:
          set_nav_stage(10);
          NavGuided(0, -2.,-2.,-nominal_alt,desired_heading);
          if ((stage_time>5)) {
            NextStage();
            break;
          }
          break;
        case 11:
          set_nav_stage(11);
          NavGuided(0, 2.,-2.,-nominal_alt,desired_heading);
          if ((stage_time>5)) {
            NextStage();
            break;
          }
          break;
        case 12:
          set_nav_stage(12);
          NavGuided(0, 2.,2.,-nominal_alt,desired_heading);
          if ((stage_time>5)) {
            NextStage();
            break;
          }
          break;
        case 13:
          set_nav_stage(13);
          NavGuided(0, 0.,0.,-nominal_alt,desired_heading);
          if ((stage_time>5)) {
            NextStage();
            break;
          }
          break;
        default:
          set_nav_stage(14);
          NextBlock();
          break;
        
      }
      break;
    default:
      tmp_nav_stage = get_nav_stage();
      switch (tmp_nav_stage) {
        case 0:
          set_nav_stage(0);
          nav_home();
          break;
        default:
          set_nav_stage(1);
          NextBlock();
          break;
        
      }
      break;
    
  }
}


#endif // NAV_C

#endif // FLIGHT_PLAN_H
